Index: xorg-server-7.2.0.0-1.5.99.1/hw/dmx/dmx.h
===================================================================
--- xorg-server-7.2.0.0-1.5.99.1.orig/hw/dmx/dmx.h
+++ xorg-server-7.2.0.0-1.5.99.1/hw/dmx/dmx.h
@@ -71,6 +71,13 @@
 #include <GL/glxint.h>
 #endif
 
+#include <xcb/xcb.h>
+#include <xcb/xcbext.h>
+
+#include <X11/Xlib-xcb.h>
+
+#include "dmxxlibio.h"
+
 typedef enum {
     PosNone = -1,
     PosAbsolute = 0,
@@ -81,21 +88,81 @@ typedef enum {
     PosRelative
 } PositionType;
 
-/** Provide the typedef globally, but keep the contents opaque outside
- * of the input routines.  \see dmxinput.h */
-typedef struct _DMXInputInfo DMXInputInfo;
+typedef struct _DMXAtom {
+    Atom                     atom;
+    xcb_intern_atom_cookie_t cookie;
+} DMXAtom;
+
+typedef struct _DMXSequence {
+    struct _DMXSequence *next;
+    unsigned long       sequence;
+} DMXSequence;
+
+typedef struct _DMXQueue {
+    DMXSequence *head;
+    DMXSequence **tail;
+} DMXQueue;
+
+typedef void (*ReplyProcPtr) (ScreenPtr           pScreen,
+			      unsigned int        sequence,
+			      xcb_generic_reply_t *reply,
+			      xcb_generic_error_t *error,
+			      void                *data);
+
+typedef struct _DMXRequest {
+    DMXSequence  base;
+    ReplyProcPtr reply;
+    void         *data;
+} DMXRequest;
+
+typedef struct _DMXPropTrans {
+    const char *name;
+    const char *format;
+    Atom       type;
+} DMXPropTrans;
+
+typedef struct _DMXSelectionMap {
+    const char *name;
+    Atom       atom;
+    Atom       beAtom;
+} DMXSelectionMap;
+
+#define DMX_DETACHED 0xff
 
 /** Provide the typedef globally, but keep the contents opaque outside
  * of the XSync statistic routines.  \see dmxstat.c */
 typedef struct _DMXStatInfo DMXStatInfo;
 
+typedef struct _DMXInputInfo {
+    DeviceIntPtr *devs;
+    int          numDevs;
+    int          eventBase;
+} DMXInputInfo;
+
+typedef struct _DMXDnDChild DMXDnDChild;
+
 /** Global structure containing information about each backend screen. */
 typedef struct _DMXScreenInfo {
-    const char   *name;           /**< Name from command line or config file */
+    DMXInputInfo input;
+
+    char          *name;          /**< Name that uniquely identifies screen  */
+    char          *display;       /**< Name from command line or config file */
     int           index;          /**< Index into dmxScreens global          */
 
     /*---------- Back-end X server information ----------*/
 
+    int fd;
+    int inDispatch;
+
+    xcb_connection_t             *connection;
+    xcb_get_input_focus_cookie_t sync;
+
+    Atom *atomTable;
+    int  atomTableSize;
+
+    DMXAtom *beAtomTable;
+    int     beAtomTableSize;
+
     Display      *beDisplay;      /**< Back-end X server's display */
     int           beWidth;        /**< Width of BE display */
     int           beHeight;       /**< Height of BE display */
@@ -106,6 +173,8 @@ typedef struct _DMXScreenInfo {
 
     int           beNumDepths;    /**< Number of depths on BE server */
     int          *beDepths;       /**< Depths from BE server */
+    int           alive;
+    int           broken;
 
     int           beNumPixmapFormats; /**< Number of pixmap formats on BE */
     XPixmapFormatValues *bePixmapFormats; /**< Pixmap formats on BE */
@@ -120,15 +189,37 @@ typedef struct _DMXScreenInfo {
     Pixel         beBlackPixel;   /**< Default black pixel for BE */
     Pixel         beWhitePixel;   /**< Default white pixel for BE */
 
+    int           beShapeEventBase;
+
+#ifdef RANDR
+    Bool          beRandr;        /**< Use RANDR support on BE server */
+    Bool          beRandrPending;
+    int           beRandrEventBase;
+#endif
+
+#ifdef MITSHM
+    Bool          beShm;          /**< Use MIT-SHM support on BE server */
+    int           beShmEventBase;
+#endif
+
+    Bool          beXkb;          /**< Use XKB support on BE server */
+    int           beXkbEventBase;
+
+    Display      *beAttachedDisplay; /**< Disabled X server's display */
+
+    char          *authType;
+    int           authTypeLen;
+    char          *authData;
+    int           authDataLen;
+
+    int           virtualFb;
+
     /*---------- Screen window information ----------*/
 
     Window        scrnWin;        /**< "Screen" window on backend display */
-    int           scrnX;          /**< X offset of "screen" WRT BE display */
-    int           scrnY;          /**< Y offset of "screen" WRT BE display */
     int           scrnWidth;      /**< Width of "screen" */
     int           scrnHeight;     /**< Height of "screen" */
-    int           scrnXSign;      /**< X offset sign of "screen" */
-    int           scrnYSign;      /**< Y offset sign of "screen" */
+    int           scrnEventMask;
 
                                   /** Default drawables for "screen" */
     Drawable      scrnDefDrawables[MAXFORMATS];
@@ -141,38 +232,61 @@ typedef struct _DMXScreenInfo {
     Window        rootWin;        /**< "Root" window on backend display */
     int           rootX;          /**< X offset of "root" window WRT "screen"*/
     int           rootY;          /**< Y offset of "root" window WRT "screen"*/
-    int           rootWidth;      /**< Width of "root" window */
-    int           rootHeight;     /**< Height of "root" window */
-
-    int           rootXOrigin;    /**< Global X origin of "root" window */
-    int           rootYOrigin;    /**< Global Y origin of "root" window */
+    int           rootEventMask;
 
-    /*---------- Shadow framebuffer information ----------*/
-
-    void         *shadow;         /**< Shadow framebuffer data (if enabled) */
-    XlibGC        shadowGC;       /**< Default GC used by shadow FB code */
-    XImage       *shadowFBImage;  /**< Screen image used by shadow FB code */
+    /*---------- Input overlay ----------*/
+    XID                              inputOverlayWid;
+    WindowPtr                        pInputOverlayWin;
+
+    /*---------- Selection information ----------*/
+    Atom                             beSelectionAtom;
+    Window                           selectionOwner;
+    xcb_get_selection_owner_cookie_t getSelectionOwner;
+    Window                           getSelectionOwnerResult;
+    Atom                             multipleAtom;
+    Atom                             atomPairAtom;
+    Atom                             incrAtom;
+
+    /*---------- DnD information ----------*/
+    Atom                               wmStateAtom;
+    Atom                               xdndProxyAtom;
+    Atom                               xdndAwareAtom;
+    Atom                               xdndSelectionAtom;
+    Atom                               xdndEnterAtom;
+    Atom                               xdndPositionAtom;
+    Atom                               xdndStatusAtom;
+    Atom                               xdndLeaveAtom;
+    Atom                               xdndDropAtom;
+    Atom                               xdndFinishedAtom;
+    Atom                               xdndTypeListAtom;
+    Atom                               xdndActionAskAtom;
+    Atom                               xdndActionListAtom;
+    Atom                               xdndActionDescriptionAtom;
+    Bool                               dndHasTypeProp;
+    XID                                dndWid;
+    XID                                dndSource;
+    XID                                dndTarget;
+    int                                dndStatus;
+    XID                                dndWindow;
+    Atom                               dndAction;
+    Atom                               dndAcceptedAction;
+    int                                dndVersion;
+    Atom                               dndType[3];
+    RegionRec                          dndBox;
+    int                                dndX;
+    int                                dndY;
+    int                                dndXPos;
+    int                                dndYPos;
+    xcb_translate_coordinates_cookie_t translateCoordinates;
+    xcb_get_property_cookie_t          getTypeProp;
+    xcb_get_property_cookie_t          getActionListProp;
+    xcb_get_property_cookie_t          getActionDescriptionProp;
+    DMXDnDChild                        *dndChildren;
+    int                                dndNChildren;
+    xcb_query_tree_cookie_t            queryTree;
 
     /*---------- Other related information ----------*/
 
-    int           shared;         /**< Non-zero if another Xdmx is running */
-
-    Bool          WMRunningOnBE;
-
-    Cursor        noCursor;
-    Cursor        curCursor;
-                                /* Support for cursors on overlapped
-                                 * backend displays. */
-    CursorPtr     cursor;
-    int           cursorVisible;
-    int           cursorNotShared; /* for overlapping screens on a backend */
-
-    PositionType  where;            /**< Relative layout information */
-    int           whereX;           /**< Relative layout information */
-    int           whereY;           /**< Relative layout information */
-    int           whereRefScreen;   /**< Relative layout information */
-
-    int           savedTimeout;     /**< Original screen saver timeout */
     int           dpmsCapable;      /**< Non-zero if backend is DPMS capable */
     int           dpmsEnabled;      /**< Non-zero if DPMS enabled */
     int           dpmsStandby;      /**< Original DPMS standby value  */
@@ -182,6 +296,9 @@ typedef struct _DMXScreenInfo {
     DMXStatInfo  *stat;             /**< Statistics about XSync  */
     Bool          needsSync;        /**< True if an XSync is pending  */
 
+    DMXQueue ignore;
+    DMXQueue request;
+
 #ifdef GLXEXT
                                   /** Visual information for glxProxy */
     int           numGlxVisuals;
@@ -212,10 +329,15 @@ typedef struct _DMXScreenInfo {
     CopyWindowProcPtr              CopyWindow;
 
     ResizeWindowProcPtr            ResizeWindow;
+    HandleExposuresProcPtr         HandleExposures;
     ReparentWindowProcPtr          ReparentWindow;
 
     ChangeBorderWidthProcPtr       ChangeBorderWidth;
 
+    ModifyPixmapHeaderProcPtr	   ModifyPixmapHeader;
+
+    SetWindowPixmapProcPtr         SetWindowPixmap;
+
     GetImageProcPtr                GetImage;
     GetSpansProcPtr                GetSpans;
 
@@ -254,15 +376,16 @@ typedef struct _DMXScreenInfo {
     TrianglesProcPtr               Triangles;
     TriStripProcPtr                TriStrip;
     TriFanProcPtr                  TriFan;
+
+    RealizeGlyphProcPtr            RealizeGlyph;
+    UnrealizeGlyphProcPtr          UnrealizeGlyph;
 #endif
 } DMXScreenInfo;
 
 /* Global variables available to all Xserver/hw/dmx routines. */
 extern int              dmxNumScreens;          /**< Number of dmxScreens */
 extern DMXScreenInfo   *dmxScreens;             /**< List of outputs */
-extern int              dmxShadowFB;            /**< Non-zero if using
-                                                 * shadow frame-buffer
-                                                 * (deprecated) */
+
 extern XErrorEvent      dmxLastErrorEvent;      /**< Last error that
                                                  * occurred */
 extern Bool             dmxErrorOccurred;       /**< True if an error
@@ -315,6 +438,23 @@ extern Bool             dmxIgnoreBadFont
 extern Bool             dmxAddRemoveScreens;    /**< True if add and
 						 * remove screens support
 						 * is enabled */
+#ifdef RANDR
+extern int             xRROutputsPerScreen;
+extern int             xRRCrtcsPerScreen;
+#endif
+
+extern DMXPropTrans     *dmxPropTrans;
+extern int              dmxPropTransNum;
+
+extern DMXSelectionMap  *dmxSelectionMap;
+extern int              dmxSelectionMapNum;
+
+#ifdef XV
+extern char             **dmxXvImageFormats;
+extern int              dmxXvImageFormatsNum;
+#endif
+
+extern char             dmxDigest[64];
 
 /** Wrap screen or GC function pointer */
 #define DMX_WRAP(_entry, _newfunc, _saved, _actual)			\
@@ -370,4 +510,6 @@ do {									\
 #define MAXSCREENSCALLOC_FATAL(o,m)     _MAXSCREENSALLOCF(o,MAXSCREENS*(m),1)
 #endif
 
+char *dmxMemDup (const char *data, int Len);
+
 #endif /* DMX_H */
Index: xorg-server-7.2.0.0-1.5.99.1/hw/dmx/dmxatom.c
===================================================================
--- /dev/null
+++ xorg-server-7.2.0.0-1.5.99.1/hw/dmx/dmxatom.c
@@ -0,0 +1,236 @@
+/*
+ * Copyright © 2008 Novell, Inc.
+ *
+ * Permission to use, copy, modify, distribute, and sell this software
+ * and its documentation for any purpose is hereby granted without
+ * fee, provided that the above copyright notice appear in all copies
+ * and that both that copyright notice and this permission notice
+ * appear in supporting documentation, and that the name of
+ * Novell, Inc. not be used in advertising or publicity pertaining to
+ * distribution of the software without specific, written prior permission.
+ * Novell, Inc. makes no representations about the suitability of this
+ * software for any purpose. It is provided "as is" without express or
+ * implied warranty.
+ *
+ * NOVELL, INC. DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
+ * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN
+ * NO EVENT SHALL NOVELL, INC. BE LIABLE FOR ANY SPECIAL, INDIRECT OR
+ * CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS
+ * OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,
+ * NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION
+ * WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
+ *
+ * Author: David Reveman <davidr@novell.com>
+ */
+
+#ifdef HAVE_DMX_CONFIG_H
+#include <dmx-config.h>
+#endif
+
+#include "dmxatom.h"
+#include "dmxsync.h"
+#include "dmxscrinit.h"
+
+static void
+dmxAddAtom (DMXScreenInfo *dmxScreen,
+	    Atom          atom,
+	    Atom          beAtom)
+{
+    int i;
+
+    if (atom >= dmxScreen->beAtomTableSize)
+    {
+	DMXAtom *table;
+
+	table = xrealloc (dmxScreen->beAtomTable,
+			  sizeof (DMXAtom) * (atom + 1));
+	if (table)
+	{
+	    for (i = dmxScreen->beAtomTableSize; i < atom; i++)
+	    {
+		table[i].atom            = None;
+		table[i].cookie.sequence = 0;
+	    }
+
+	    table[atom].atom            = beAtom;
+	    table[atom].cookie.sequence = 0;
+
+	    dmxScreen->beAtomTable     = table;
+	    dmxScreen->beAtomTableSize = atom + 1;
+	}
+    }
+    else
+    {
+	dmxScreen->beAtomTable[atom].atom = beAtom;
+    }
+
+    if (beAtom)
+    {
+	if (beAtom >= dmxScreen->atomTableSize)
+	{
+	    Atom *table;
+
+	    table = xrealloc (dmxScreen->atomTable,
+			      sizeof (Atom) * (beAtom + 1));
+	    if (table)
+	    {
+		for (i = dmxScreen->atomTableSize; i < beAtom; i++)
+		    table[i] = None;
+
+		table[beAtom] = atom;
+
+		dmxScreen->atomTable     = table;
+		dmxScreen->atomTableSize = beAtom + 1;
+	    }
+	}
+	else
+	{
+	    dmxScreen->atomTable[beAtom] = atom;
+	}
+    }
+}
+
+static void
+dmxInternAtomReply (ScreenPtr           pScreen,
+		    unsigned int        sequence,
+		    xcb_generic_reply_t *reply,
+		    xcb_generic_error_t *error,
+		    void                *data)
+{
+    DMXScreenInfo *dmxScreen = &dmxScreens[pScreen->myNum];
+    Atom          atom = (Atom) data;
+
+    dmxScreen->beAtomTable[atom].cookie.sequence = 0;
+
+    if (reply)
+    {
+	xcb_intern_atom_reply_t *xatom = (xcb_intern_atom_reply_t *) reply;
+
+	dmxAddAtom (dmxScreen, atom, xatom->atom);
+    }
+}
+
+static unsigned int
+dmxBERequestAtom (DMXScreenInfo *dmxScreen,
+		  Atom	        atom)
+{
+    if (atom < dmxScreen->beAtomTableSize)
+	if (dmxScreen->beAtomTable[atom].atom)
+	    return 0;
+
+    if (atom <= XA_LAST_PREDEFINED)
+    {
+	dmxAddAtom (dmxScreen, atom, atom);
+    }
+    else
+    {
+	char *name;
+
+	dmxAddAtom (dmxScreen, atom, None);
+
+	name = NameForAtom (atom);
+	if (name && atom < dmxScreen->beAtomTableSize)
+	{
+	    dmxScreen->beAtomTable[atom].cookie =
+		xcb_intern_atom (dmxScreen->connection,
+				 FALSE,
+				 strlen (name),
+				 name);
+	    
+	    return dmxScreen->beAtomTable[atom].cookie.sequence;
+	}
+    }
+
+    return 0;
+}
+
+Atom
+dmxAtom (DMXScreenInfo *dmxScreen,
+	 Atom	       beAtom)
+{
+    if (beAtom < dmxScreen->atomTableSize)
+	if (dmxScreen->atomTable[beAtom])
+	    return dmxScreen->atomTable[beAtom];
+
+    if (beAtom <= XA_LAST_PREDEFINED)
+    {
+	dmxAddAtom (dmxScreen, beAtom, beAtom);
+    }
+    else
+    {
+	xcb_get_atom_name_reply_t *reply;
+	Atom                      atom;
+
+	reply = xcb_get_atom_name_reply
+	    (dmxScreen->connection,
+	     xcb_get_atom_name (dmxScreen->connection,
+				beAtom),
+	     NULL);
+	if (!reply)
+	    return None;
+
+	atom = MakeAtom ((char *) (reply + 1), reply->name_len, TRUE);
+
+	free (reply);
+
+	if (!atom)
+	    return None;
+
+	dmxAddAtom (dmxScreen, atom, beAtom);
+    }
+
+    if (beAtom < dmxScreen->atomTableSize)
+	return dmxScreen->atomTable[beAtom];
+
+    return None;
+}
+
+Atom
+dmxBEAtom (DMXScreenInfo *dmxScreen,
+	   Atom		 atom)
+{
+    xcb_intern_atom_cookie_t cookie = { 0 };
+
+    if (atom < dmxScreen->beAtomTableSize)
+    {
+	if (dmxScreen->beAtomTable[atom].atom)
+	    return dmxScreen->beAtomTable[atom].atom;
+
+	cookie = dmxScreen->beAtomTable[atom].cookie;
+    }
+
+    if (!cookie.sequence)
+	cookie.sequence = dmxBERequestAtom (dmxScreen, atom);
+    
+    if (cookie.sequence)
+    {
+	xcb_intern_atom_reply_t *reply;
+
+	reply = xcb_intern_atom_reply (dmxScreen->connection, cookie, NULL);
+
+	dmxInternAtomReply (screenInfo.screens[dmxScreen->index],
+			    cookie.sequence,
+			    (xcb_generic_reply_t *) reply,
+			    NULL,
+			    (void *) atom);
+    }
+
+    if (atom < dmxScreen->beAtomTableSize)
+	return dmxScreen->beAtomTable[atom].atom;
+
+    return None;
+}
+
+void
+dmxBEPrefetchAtom (DMXScreenInfo *dmxScreen,
+		   Atom	         atom)
+{
+    unsigned int sequence;
+
+    sequence = dmxBERequestAtom (dmxScreen, atom);
+    if (sequence)
+	dmxAddRequest (&dmxScreen->request,
+		       dmxInternAtomReply,
+		       sequence,
+		       (void *) atom);
+}
Index: xorg-server-7.2.0.0-1.5.99.1/hw/dmx/dmxatom.h
===================================================================
--- /dev/null
+++ xorg-server-7.2.0.0-1.5.99.1/hw/dmx/dmxatom.h
@@ -0,0 +1,35 @@
+/*
+ * Copyright © 2008 Novell, Inc.
+ *
+ * Permission to use, copy, modify, distribute, and sell this software
+ * and its documentation for any purpose is hereby granted without
+ * fee, provided that the above copyright notice appear in all copies
+ * and that both that copyright notice and this permission notice
+ * appear in supporting documentation, and that the name of
+ * Novell, Inc. not be used in advertising or publicity pertaining to
+ * distribution of the software without specific, written prior permission.
+ * Novell, Inc. makes no representations about the suitability of this
+ * software for any purpose. It is provided "as is" without express or
+ * implied warranty.
+ *
+ * NOVELL, INC. DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
+ * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN
+ * NO EVENT SHALL NOVELL, INC. BE LIABLE FOR ANY SPECIAL, INDIRECT OR
+ * CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS
+ * OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,
+ * NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION
+ * WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
+ *
+ * Author: David Reveman <davidr@novell.com>
+ */
+
+#ifndef DMXATOM_H
+#define DMXATOM_H
+
+#include "dmx.h"
+
+extern Atom dmxAtom (DMXScreenInfo *dmxScreen, Atom beAtom);
+extern Atom dmxBEAtom (DMXScreenInfo *dmxScreen, Atom atom);
+extern void dmxBEPrefetchAtom (DMXScreenInfo *dmxScreen, Atom atom);
+
+#endif /* DMXATOM_H */
Index: xorg-server-7.2.0.0-1.5.99.1/hw/dmx/dmxavahi.c
===================================================================
--- /dev/null
+++ xorg-server-7.2.0.0-1.5.99.1/hw/dmx/dmxavahi.c
@@ -0,0 +1,358 @@
+/*
+ * Copyright © 2008 Novell, Inc.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice (including the next
+ * paragraph) shall be included in all copies or substantial portions of the
+ * Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ *
+ * Authors: Hubert Figuiere <hfiguiere@novell.com>
+ *          David Reveman <davidr@novell.com>
+ */
+
+#ifdef HAVE_DMX_CONFIG_H
+#include <dmx-config.h>
+#endif
+
+#include <stdlib.h>
+#include <unistd.h>
+#include <avahi-client/client.h>
+#include <avahi-client/publish.h>
+#include <avahi-common/watch.h>
+
+#include "dix.h"
+#include "os.h"
+#include "opaque.h"
+#include "dmxavahi.h"
+
+typedef struct _DMXAvahiPoll DMXAvahiPoll;
+
+struct AvahiWatch {
+    struct AvahiWatch *next;
+
+    int                fd;
+    AvahiWatchEvent    event;
+    AvahiWatchCallback callback;
+    void               *userdata;
+
+    DMXAvahiPoll *p;
+};
+
+struct AvahiTimeout {
+    struct AvahiTimeout *next;
+
+    AvahiTimeoutCallback callback;
+    void                 *userdata;
+	
+    DMXAvahiPoll *p;
+    OsTimerPtr   timer;
+};
+
+struct _DMXAvahiPoll {
+    AvahiPoll base;
+
+    AvahiWatch   *watches;
+    AvahiTimeout *timeouts;
+};
+
+static DMXAvahiPoll    avahi_poll;
+static AvahiClient     *avahi_client;
+static AvahiEntryGroup *avahi_group;
+
+static const char * _service_name = "DMX service on %s";
+
+static AvahiWatch *
+dmx_avahi_watch_new (const AvahiPoll    *api,
+		     int		fd,
+		     AvahiWatchEvent    event,
+		     AvahiWatchCallback callback,
+		     void		*userdata)
+{
+    DMXAvahiPoll *p = (DMXAvahiPoll *) api;
+    AvahiWatch   *w;
+
+    w = xalloc (sizeof (AvahiWatch));
+    if (!w)
+	return NULL;
+
+    w->fd       = fd;
+    w->event    = event;
+    w->callback = callback;
+    w->userdata = userdata;
+    w->p        = p;
+
+    w->next = p->watches;
+    p->watches = w;
+
+    if (w->event & AVAHI_WATCH_IN)
+	AddEnabledDevice (fd);
+
+    return w;
+}
+
+static void
+dmx_avahi_watch_update (AvahiWatch      *w,
+			AvahiWatchEvent event)
+{
+    if (event & AVAHI_WATCH_IN)
+    {
+	if (!(w->event & AVAHI_WATCH_IN))
+	    AddEnabledDevice (w->fd);
+    }
+    else
+    {
+	if (w->event & AVAHI_WATCH_IN)
+	    RemoveEnabledDevice (w->fd);
+    }
+
+    w->event = event;
+}
+
+static AvahiWatchEvent
+dmx_avahi_watch_get_events (AvahiWatch *w)
+{
+    return AVAHI_WATCH_IN;
+}
+
+static void
+dmx_avahi_watch_free (AvahiWatch *w)
+{
+    DMXAvahiPoll *p = w->p;
+    AvahiWatch   *prev;
+
+    for (prev = p->watches; prev; prev = prev->next)
+	if (prev->next == w)
+	    break;
+
+    if (prev)
+	prev->next = w->next;
+    else
+	p->watches = w->next;
+
+    if (w->event & AVAHI_WATCH_IN)
+	RemoveEnabledDevice (w->fd);
+
+    free (w);
+}
+
+static CARD32
+avahi_poll_timeout (OsTimerPtr timer,
+		    CARD32     time,
+		    pointer    arg)
+{
+    AvahiTimeout *t = (AvahiTimeout *) arg;
+
+    (*t->callback) (t, t->userdata);
+
+    return 0;
+}
+
+static AvahiTimeout *
+dmx_avahi_timeout_new (const AvahiPoll      *api,
+		       const struct timeval *tv,
+		       AvahiTimeoutCallback callback,
+		       void                 *userdata)
+{
+    DMXAvahiPoll *p = (DMXAvahiPoll *) api;
+    AvahiTimeout *t;
+
+    t = xalloc (sizeof (AvahiTimeout));
+    if (!t)
+	return NULL;
+
+    t->callback = callback;
+    t->userdata = userdata;
+    t->timer    = NULL;
+    t->p        = p;
+    
+    t->next = p->timeouts;
+    p->timeouts = t;
+
+    if (tv)
+	t->timer = TimerSet (NULL,
+			     0,
+			     ((CARD16) tv->tv_sec) * 1000 + tv->tv_usec / 1000,
+			     avahi_poll_timeout,
+			     t);
+
+    return t;
+}
+
+static void
+dmx_avahi_timeout_update (AvahiTimeout         *t,
+			  const struct timeval *tv)
+{
+    if (tv)
+	t->timer = TimerSet (t->timer,
+			     0,
+			     ((CARD16) tv->tv_sec) * 1000 + tv->tv_usec / 1000,
+			     avahi_poll_timeout,
+			     t);
+    else
+	TimerCancel (t->timer);
+}
+
+static void
+dmx_avahi_timeout_free (AvahiTimeout *t)
+{
+    DMXAvahiPoll *p = t->p;
+    AvahiTimeout *prev;
+
+    for (prev = p->timeouts; prev; prev = prev->next)
+	if (prev->next == t)
+	    break;
+
+    if (prev)
+	prev->next = t->next;
+    else
+	p->timeouts = t->next;
+
+    TimerFree (t->timer);
+
+    free (t);
+}
+
+static void
+avahi_poll_block_handler (pointer   blockData,
+			  OSTimePtr pTimeout,
+			  pointer   pReadMask)
+{
+}
+
+static void
+avahi_poll_wakeup_handler (pointer blockData,
+			   int     result,
+			   pointer pReadMask)
+{
+    DMXAvahiPoll *p = (DMXAvahiPoll *) blockData;
+    AvahiWatch   *w = p->watches;
+    fd_set       *fds = (fd_set *) pReadMask;
+
+    while (w)
+    {
+	AvahiWatch *next = w->next;
+
+	if (FD_ISSET (w->fd, fds))
+	    (*w->callback) (w, w->fd, AVAHI_WATCH_IN, w->userdata);
+
+	w = next;
+    }
+}
+
+static void
+dmx_avahi_poll_init (DMXAvahiPoll *p)
+{
+    p->base.watch_new        = dmx_avahi_watch_new;
+    p->base.watch_update     = dmx_avahi_watch_update;
+    p->base.watch_get_events = dmx_avahi_watch_get_events;
+    p->base.watch_free       = dmx_avahi_watch_free;
+    p->base.timeout_new      = dmx_avahi_timeout_new;
+    p->base.timeout_update   = dmx_avahi_timeout_update;
+    p->base.timeout_free     = dmx_avahi_timeout_free;
+
+    RegisterBlockAndWakeupHandlers (avahi_poll_block_handler,
+				    avahi_poll_wakeup_handler,
+				    p);
+}
+
+static void
+dmx_avahi_poll_fini (DMXAvahiPoll *p)
+{
+    while (p->timeouts)
+	dmx_avahi_timeout_free (p->timeouts);
+
+    while (p->watches)
+	dmx_avahi_watch_free (p->watches);
+
+    RemoveBlockAndWakeupHandlers (avahi_poll_block_handler,
+				  avahi_poll_wakeup_handler,
+				  p);
+}
+
+static void
+avahi_client_callback (AvahiClient      *c,
+		       AvahiClientState state,
+		       void             *userdata)
+{
+    switch (state) {
+    case AVAHI_CLIENT_S_RUNNING: {
+	char hname[512], name[576];
+
+	if (gethostname (hname, sizeof (hname)))
+	    break;
+
+	sprintf (name, _service_name, hname);
+
+	avahi_group = avahi_entry_group_new (c, 0, 0);
+	if (avahi_group)
+	{
+	    avahi_entry_group_add_service (avahi_group,
+					   AVAHI_IF_UNSPEC,
+					   AVAHI_PROTO_UNSPEC,
+					   0, 
+					   name,
+					   "_dmx._tcp",
+					   0,
+					   0,
+					   6000 + atoi (display),
+					   NULL);
+
+	    avahi_entry_group_commit (avahi_group);
+	}
+    } break;
+    case AVAHI_CLIENT_FAILURE:
+    case AVAHI_CLIENT_S_COLLISION:
+    case AVAHI_CLIENT_CONNECTING:
+	break;
+    case AVAHI_CLIENT_S_REGISTERING:
+	if (avahi_group)
+	    avahi_entry_group_reset (avahi_group);
+    default:
+	break;
+    }
+}
+
+void
+dmx_avahi_init (void)
+{
+    dmx_avahi_poll_init (&avahi_poll);
+	
+    avahi_group  = NULL;
+    avahi_client = avahi_client_new (&avahi_poll.base,
+				     0, 
+				     avahi_client_callback,
+				     NULL,
+				     NULL);
+}
+
+void
+dmx_avahi_fini (void)
+{
+    if (avahi_group)
+    {
+	avahi_entry_group_free (avahi_group);
+	avahi_group = NULL;
+    }
+
+    if (avahi_client)
+    {
+	avahi_client_free (avahi_client);
+	avahi_client = NULL;
+    }
+
+    dmx_avahi_poll_fini (&avahi_poll);
+}
Index: xorg-server-7.2.0.0-1.5.99.1/hw/dmx/dmxavahi.h
===================================================================
--- /dev/null
+++ xorg-server-7.2.0.0-1.5.99.1/hw/dmx/dmxavahi.h
@@ -0,0 +1,40 @@
+/*
+ * Copyright © 2008 Novell, Inc.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice (including the next
+ * paragraph) shall be included in all copies or substantial portions of the
+ * Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ *
+ * Authors: Hubert Figuiere <hfiguiere@novell.com>
+ *          David Reveman <davidr@novell.com>
+ */
+
+
+#ifndef DMX_AVAHI_H
+#define DMX_AVAHI_H
+
+#ifdef HAVE_DMX_CONFIG_H
+#include <dmx-config.h>
+#endif
+
+#ifdef HAVE_AVAHI
+extern void dmx_avahi_init (void);
+extern void dmx_avahi_fini (void);
+#endif
+
+#endif
